#!/usr/local/bin/perl
# Produces a stub files with the nth heading occupying the nth field
# takes as input the SAS outputs from running PROC FREQ on the .PRC files

open(STUBFILE, shift(@ARGV));

while ($upcfileline=<>)
{    
    ($obs, $upccode, $count) = ( $upcfileline =~ /^\D+(\d+)\D+(\d+)\D+(\d+)/);
    if (($upccode =~ /^\d+$/) && ($count =~ /^\d+$/))
    {     
	$upccode = substr($upccode, -11, 11);
	$sales{$upccode} += $count;
	$totalsales += $count;
    }
}
$upcstring = join(' ', keys(%sales));

while ($currentline = <STUBFILE>)
{
    $currentline =~ /(^[ ]*)(.+)/;
    $numblanks = length($1); $rest = $2;
    $type = substr($rest,7,15) if ($numblanks == 1);
    $manuf= substr($rest,0,25) if ($numblanks == 4);
    $brand= substr($rest,0,20) if ($numblanks == 6);
    if ($numblanks == 8)
    {
	$upc = sprintf("%0d%05d%05d", 
       		       substr($currentline, 43, 1), 
		       substr($currentline, 45, 5), 
		       substr($currentline, 51, 5));
	if ($upcstring =~ /$upc/) {
	    $prod = substr($rest,1, 61);
	    $percent = 100*$sales{$upc}/$totalsales;
	    $line = sprintf("%5d %5.2f %s %s %s %s\n", $sales{$upc}, $percent, $type, $manuf, $brand, $prod);
	    push(@lines, $line);
	}
    }
}

$cumpercent=0;
@lines = reverse(sort(@lines));
foreach $line (@lines) {
    $sales = substr($line, 0, 5);
    $percent = 100*$sales/$totalsales;
    $cumsales += $sales;
    $cumpercent = 100*$cumsales/$totalsales;
    substr($line, 6, 5) = sprintf("%5.2f %6.2f", $percent, $cumpercent);
    print $line;
}
