#!/usr/local/bin/perl

# computes and prints, for each panelist in TRIPFILE, 
# panelist ID, number of weeks in panel, number of trips, frequency.


$trpfilename  = shift(@ARGV);
open(TRPFILE,  $trpfilename);

$oldpanelist = 0;
$firstweek = 0;
$lastweek = 0;
$numtrips=1;
while ($trpfileline = <TRPFILE>)
{
    $panelist = substr($trpfileline, 0, 8);
    $week     = substr($trpfileline, 8, 3);
    if ($panelist == $oldpanelist) 
    {
	$lastweek = $week;
	$numtrips++;
    }
    else
    {
	$nweeks{$oldpanelist} = ($lastweek - $firstweek + 1);
	$ntrips{$oldpanelist} = $numtrips;
	
	$numtrips=1;
	$oldpanelist = $panelist;
	$firstweek = $week;
    }
}

# fix exit conditions, last panelist not done right

foreach $panelist (sort(keys(%nweeks)))
{
    printf("%8d%03d%03d%6.3f\n", 
	   $panelist, 
	   $nweeks{$panelist}, 
	   $ntrips{$panelist},
	   $ntrips{$panelist}/$nweeks{$panelist});
}


