#!/usr/local/bin/perl
foreach $fullmrcfilename (@ARGV) {
    ($basefilename) = ($fullmrcfilename =~ /([^\/]+)$/);
    ($category) = ($basefilename =~ /^([^\.]+)/);
    if ($basefilename =~ /\.gz$/) {
	open(MRCFILE, "/usr/pubsw/bin/zcat $fullmrcfilename |")
	}
    else
    {
	open(MRCFILE, "cat $fullmrcfilename |");
    }
    while($mrcline=<MRCFILE>) {
	$sales{substr($mrcline, 1, 4),$category} += (substr($mrcline, 20, 5) * substr($mrcline, 27, 5));
    }
}

foreach $store_category (keys(%sales)) {
    ($store, $category) = split($;, $store_category);
    $store_sales{$store} += $sales{$store_category};
    $category_sales{$category} += $sales{$store_category};
}

@store = sort keys(%store_sales);
@category = sort keys(%category_sales);

printf "%4s", "STOR";
foreach $category (@category) {
    printf " %10s", substr($category, 0, 10);
}
printf "\n";

foreach $store (@store) {
    printf "%4s", $store;
    foreach $category (@category) {
	printf " %10.2f", $sales{$store, $category};
    }
    printf "\n";
}
